<?php

namespace Modules\Lpj\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Modules\Lpj\Models\CategoryDaftarPustaka;
use Modules\Lpj\Http\Requests\CategoryDaftarPustakaRequest;

class CategoryDaftarPustakaController extends Controller
{
     public $user;
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('lpj::category-daftar-pustaka.index');
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('lpj::category-daftar-pustaka.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CategoryDaftarPustakaRequest $request)
    {
        $validated = $request->validated();
        if ($validated) {
            try {
                CategoryDaftarPustaka::create($validated);
                return redirect()->route('category-daftar-pustaka.index')->with('success', 'Data Berhasil Disimpan');
            } catch (\Throwable $th) {
                return redirect()->route('category-daftar-pustaka.index')->with('error', $th->getMessage());
            }
        }

    }

    /**
     * Show the specified resource.
     */
    public function show($id)
    {
        $category = CategoryDaftarPustaka::where('id', $id)->first();
        return view('lpj::category-daftar-pustaka.show', compact('category'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($id)
    {
        return view('lpj::category-daftar-pustaka.create', ['category' => CategoryDaftarPustaka::where('id', $id)->first()]);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(CategoryDaftarPustakaRequest $request, $id)
    {
        $validated = $request->validated();
        if ($validated) {
            try {
                CategoryDaftarPustaka::where('id', $id)->update($validated);
                return redirect()->route('category-daftar-pustaka.index')->with('success', 'Data Berhasil Disimpan');
            } catch (\Throwable $th) {
                return redirect()->route('category-daftar-pustaka.index')->with('error', $th->getMessage());
            }
        }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        try {
            CategoryDaftarPustaka::where('id', $id)->delete();
            return response()->json(['success' => true, 'message' => 'Data Berhasil Dihapus']);
        } catch (\Throwable $th) {
            return response()->json(['success' => false, 'message' => $th->getMessage()]);
        }
    }

    public function dataForDatatables(Request $request)
    {
        if (is_null($this->user) || !$this->user->can('jenis_aset.view')) {
            //abort(403, 'Sorry! You are not allowed to view users.');
        }

        // Retrieve data from the database
        $query = CategoryDaftarPustaka::query();

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = $request->get('search');
            $query->where(function ($q) use ($search) {
                $q->where('code', 'LIKE', "%$search%");
                $q->orWhere('name', 'LIKE', "%$search%");
            });
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->get();

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = 0 + 1;

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }
}
